//---------------------------------------------------------------------------
#ifndef NNTPMods2H
#define NNTPMods2H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <IdBaseComponent.hpp>
#include <IdComponent.hpp>
#include <IdIOHandler.hpp>
#include <IdIOHandlerSocket.hpp>
#include <IdMessageClient.hpp>
#include <IdNNTP.hpp>
#include <IdSSLOpenSSL.hpp>
#include <IdTCPClient.hpp>
#include <IdTCPConnection.hpp>
#include <IdSocks.hpp>
#include "IdCustomTransparentProxy.hpp"
#include "IdExplicitTLSClientServerBase.hpp"
#include "IdIOHandlerStack.hpp"
#include "IdSSL.hpp"
#include "global.h"
#include "msgmans.h"
#include <IdBaseComponent.hpp>
#include <IdIntercept.hpp>
#include <IdLogBase.hpp>
#include <IdLogEvent.hpp>
#include <IdLogStream.hpp>
class TNNTPMod2;
//---------------------------------------------------------------------------

class TNNTPThread : public TThread
{
private:
protected:
public:
   int mode;
   TNNTPMod2 *NNTPMod2;
	__fastcall virtual TNNTPThread(bool CreateSuspended);
	__fastcall virtual TNNTPThread(TForm *Owner, const AnsiString &account, int mode);
	__fastcall virtual~TNNTPThread();
	void __fastcall Execute();
};

void __fastcall GetNNTPMail(TForm *Owner, const AnsiString &account, int mode);

class TNNTPMod2 : public TForm
{
__published:	// IDE-managed Components
	TIdNNTP *NNTP;
	TIdSSLIOHandlerSocketOpenSSL *SSLIOHandler;
	TIdSocksInfo *SocksInfo;
	TIdLogEvent *IdLogEvent;
	void __fastcall NNTPDisconnected(TObject *Sender);
	void __fastcall NNTPNewNewsList(AnsiString AMsgID, bool &ACanContinue);
	void __fastcall NNTPStatus(TObject *ASender, const TIdStatus AStatus,
		  const AnsiString AStatusText);
	void __fastcall NNTPTLSNotAvailable(TObject *Asender, bool &VContinue);
	void __fastcall NNTPWorkEnd(TObject *ASender, TWorkMode AWorkMode);
	void __fastcall NNTPXHDREntry(AnsiString AHeader, AnsiString AMsg,
		  AnsiString AHeaderData, bool &ACanContinue);
	void __fastcall NNTPNewGroupsList(AnsiString ANewsgroup, __int64 ALow,
          __int64 AHigh, AnsiString AType, bool &ACanContinue);
	void __fastcall NNTPNewsgroupList(AnsiString ANewsgroup, __int64 ALow,
          __int64 AHigh, AnsiString AType, bool &ACanContinue);
	void __fastcall NNTPWork(TObject *ASender, TWorkMode AWorkMode,
          __int64 AWorkCount);
	void __fastcall NNTPWorkBegin(TObject *ASender, TWorkMode AWorkMode,
          __int64 AWorkCountMax);
	void __fastcall NNTPXOVER(__int64 AArticleIndex, AnsiString ASubject,
          AnsiString AFrom, TDateTime ADate, AnsiString AMsgId,
          AnsiString AReferences, int AByteCount, int ALineCount,
          AnsiString AExtraData, bool &VCanContinue);
	void __fastcall NNTPConnected(TObject *Sender);
	void __fastcall IdLogEventReceived(TComponent *ASender, const AnsiString AText,
          const AnsiString AData);
	void __fastcall IdLogEventSent(TComponent *ASender, const AnsiString AText,
          const AnsiString AData);
	void __fastcall IdLogEventReceive(TIdConnectionIntercept *ASender,
          TIdBytes &ABuffer);
	void __fastcall IdLogEventSend(TIdConnectionIntercept *ASender,
          TIdBytes &ABuffer);
	void __fastcall IdLogEventStatus(TComponent *ASender, const AnsiString AText);
	void __fastcall IdLogEventConnect(TIdConnectionIntercept *ASender);
	void __fastcall IdLogEventDisconnect(TIdConnectionIntercept *ASender);
private:	// User declarations
	void __fastcall OwnerPerform(UINT msg, WPARAM wparam, LPARAM lparam);
	void __fastcall ErrorBox(const AnsiString &text);
	void __fastcall ShowProgress(const double current, const double total, const AnsiString &article);
	void __fastcall ShowStatus(const AnsiString &msg);
	bool __fastcall SetupProxy();
	int  __fastcall PercentComplete(double next);
	void __fastcall Display(const AnsiString &msg);
	bool __fastcall SubjectMatch(const AnsiString &msgsubject);
	bool __fastcall SubjectMatch(TMsgManager *msg);
	void __fastcall RetrieveComplete();
	void __fastcall CatchupComplete();
	void __fastcall CheckComplete();
	void __fastcall SaveLog();
	//bool __fastcall ShouldIgnoreError(const AnsiString &error);
public:		// User declarations
	//TMsgManager *msgman;
	__int64 next, totalarticles, curmsg;
	int maxloglines, mails, lasterror;
	AnsiString nntpproxy, newsgroup, account, server;
	bool working, canceled, aborted, timeout, displaying, goterror;
	TStringList *profile, *log, *proxy, *subjects; //, *ignoreerrors; //, *data

	__fastcall TNNTPMod2(TComponent* Owner);
	__fastcall virtual~TNNTPMod2();
	bool __fastcall CatchUpGroup();
	bool __fastcall CheckForMail();
	bool __fastcall GetTheMail();
	//message function
	void __fastcall WMNNTPTimeout(TMessage &Msg);
	void __fastcall WMNNTPCancel(TMessage &Msg);
	// message map
	BEGIN_MESSAGE_MAP
	MESSAGE_HANDLER(WM_NNTPTIMEOUTTIMER, TMessage, WMNNTPTimeout)
	MESSAGE_HANDLER(WM_NNTPCANCEL, TMessage, WMNNTPCancel)
	END_MESSAGE_MAP(TForm)
};

const int modeCatchUp = 1;
const int modeChkMail = 2;
const int modeGetMail = 3;

//---------------------------------------------------------------------------
extern PACKAGE TNNTPMod2 *NNTPMod2;
extern HANDLE NNTPModHandle;
extern TNNTPThread *NNTPThrd;
extern int NNTPThrdHandle;
//---------------------------------------------------------------------------
#endif
