/*
*  blenddlgs.cpp 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "inifiles.hpp"

#include "global.h" 
#include "blenddlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TBlendDlg *BlendDlg;
AnsiString blendmsg =
"Your nym identities may be in danger. Let me explain a blending attack. You have "
"more than 1 nym. Lets say, you have NymA and NymB. Someone believes both "
"NymA and NymB belong to you. Their tactic for exposing this is:\n\n"
"They address the message to NymA but they encrypt the message to NymB. If you "
"unknowingly decrypt the message and reply as NymA, the attacker knows both nyms "
"belong to you. If this is truely a blending attack, your only safe reply to the "
"sender is, \"your message wouldn't decrypt.\"\n\nTake care.";
//---------------------------------------------------------------------------

void __fastcall ShowPossibleBlendingAttack(TForm *Owner, const AnsiString &msgrecip,
   const AnsiString &nymrecip)
{
   TBlendDlg *blenddlg = new TBlendDlg(Owner);
   blenddlg->Label3->Caption = "Addressed To: \t"+msgrecip;
   blenddlg->Label4->Caption = "Encrypted To: \t"+nymrecip;
   blenddlg->ShowModal();
   delete blenddlg;
}
//---------------------------------------------------------------------------

__fastcall TBlendDlg::TBlendDlg(TComponent* Owner)
	: TForm(Owner)
{
   TIniFile *ini = new TIniFile(AppIni());
   AssignFont(Font, ini->ReadString("settings", "dialogfont", OptsDefDialogFont));
   delete ini;
   RichEdit1->Lines->Text = blendmsg;
   RichEdit1->SelStart = 0;
   RichEdit1->Perform(EM_SCROLLCARET, 0, 0);
}
//---------------------------------------------------------------------------
