/*
*  esub.h 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#ifndef esubH
#define esubH
//---------------------------------------------------------------------------
// Esub Functions
//bool __fastcall HasIDEAeSub();
AnsiString __fastcall ESUBDll();
bool __stdcall IsSubjectIDEAeSub(const AnsiString &encsubject, const AnsiString &subject, const AnsiString &key);
bool __stdcall IsSubjectBLOWeSub(const AnsiString &encsubject, const AnsiString &subject, const AnsiString &key);
bool __stdcall EncryptSubjectBLOW(const AnsiString &subject, const AnsiString &key, AnsiString &iv, AnsiString &encsubject);
bool __stdcall MD5Hash(const AnsiString &data, unsigned char *hash);

typedef int __stdcall (*PSENCRYPTSUBJECTIDEA)(char*, char*, char*);
typedef int __stdcall (*PSTESTSUBJECTIDEA)(char*, char*, char*);
typedef int __stdcall (*PSMD5HASH)(const unsigned char*, unsigned char*);

extern HINSTANCE hESubLib;

/*
 **********************************************************************
 ** md5.h -- Header file for implementation of MD5                   **
 ** RSA Data Security, Inc. MD5 Message Digest Algorithm             **
 ** Created: 2/17/90 RLR                                             **
 ** Revised: 12/27/90 SRD,AJ,BSK,JT Reference C version              **
 ** Revised (for MD5): RLR 4/27/91                                   **
 **   -- G modified to have y&~z instead of y&z                      **
 **   -- FF, GG, HH modified to add in last register done            **
 **   -- Access pattern: round 2 works mod 5, round 3 works mod 3    **
 **   -- distinct additive constant for each step                    **
 **   -- round 4 added, working mod 7                                **
 **********************************************************************
 */

/*
 **********************************************************************
 ** Copyright (C) 1990, RSA Data Security, Inc. All rights reserved. **
 **                                                                  **
 ** License to copy and use this software is granted provided that   **
 ** it is identified as the "RSA Data Security, Inc. MD5 Message     **
 ** Digest Algorithm" in all material mentioning or referencing this **
 ** software or this function.                                       **
 **                                                                  **
 ** License is also granted to make and use derivative works         **
 ** provided that such works are identified as "derived from the RSA **
 ** Data Security, Inc. MD5 Message Digest Algorithm" in all         **
 ** material mentioning or referencing the derived work.             **
 **                                                                  **
 ** RSA Data Security, Inc. makes no representations concerning      **
 ** either the merchantability of this software or the suitability   **
 ** of this software for any particular purpose.  It is provided "as **
 ** is" without express or implied warranty of any kind.             **
 **                                                                  **
 ** These notices must be retained in any copies of any part of this **
 ** documentation and/or software.                                   **
 **********************************************************************
 */

bool __fastcall InitESUB32Library();
void __fastcall FreeESUB32Library();

/* typedef a 32 bit type */
typedef unsigned long int UINT4;

/* Data structure for MD5 (Message Digest) computation */
typedef struct {
  UINT4 i[2];                   /* number of _bits_ handled mod 2^64 */
  UINT4 buf[4];                                    /* scratch buffer */
  unsigned char in[64];                              /* input buffer */
  unsigned char digest[16];     /* actual digest after MD5Final call */
} MD5_CTX;

void __fastcall MD5Init(MD5_CTX *mdContext);
void __fastcall MD5Update(MD5_CTX *mdContext, unsigned char *inBuf, unsigned int inLen);
void __fastcall MD5Final(MD5_CTX *mdContext);
static void Transform (UINT4 *buf, UINT4 *in);
//---------------------------------------------------------------------------
#endif
 
