/*
*  gpg.h 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#ifndef gpgH
#define gpgH
#include "gpgme.h"
//---------------------------------------------------------------------------

bool __fastcall InitGPGMeLibrary();
bool __fastcall GPGMEDecryptVerifyMessage(TForm *Owner, TStrings *Message, AnsiString &Passphrase);

typedef const char* (*GPGMECHECKVERSIONINTERNAL) (const char*, size_t);
typedef const gpgme_error_t (*GPGMENEW)(gpgme_ctx_t*);
typedef const char* (*GPGMESTRERROR)(gpgme_error_t);
typedef const char* (*GPGMESTRSOURCE)(gpgme_error_t);
typedef void (*GPGMESETPASSPHRASECB)(gpgme_ctx_t, gpgme_passphrase_cb_t, void*);
typedef gpgme_error_t (*GPGMEDATANEWFROMMEM)(gpgme_data_t*, const char*, size_t, int copy);
typedef gpgme_error_t (*GPGDATANEW)(gpgme_data_t*);
typedef gpgme_error_t (*GPGMEOPDECRYPT)(gpgme_ctx_t, gpgme_data_t, gpgme_data_t);

#endif
