/*
*  proxymandlgs.h 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef proxymandlgsH
#define proxymandlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------

bool __fastcall ManageProxies(TForm *Owner);
bool __fastcall LoadProxyBoxSMTP(TComboBox *ProxyBox, AnsiString &defsmtp);
bool __fastcall LoadProxyBoxHTTP(TComboBox *ProxyBox, AnsiString &defhttp);


class TProxyManDlg : public TForm
{
__published:	// IDE-managed Components
        TButton *OkBtn;
        TListView *ListView;
        TPopupMenu *PopupMenu1;
        TMenuItem *Add1;
        TMenuItem *Edit1;
        TMenuItem *Delete1;
        TMenuItem *N1;
        TMenuItem *Resizedialog1;
        TMenuItem *Locksize1;
	TComboBox *NNTPBox;
        TLabel *Label1;
        TTimer *Timer1;
        TButton *NewBtn;
        TButton *EditBtn;
        TButton *DeleteBtn;
	TButton *HelpBtn;
        void __fastcall Add1Click(TObject *Sender);
        void __fastcall PopupMenu1Popup(TObject *Sender);
        void __fastcall Resizedialog1Click(TObject *Sender);
        void __fastcall Locksize1Click(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall NNTPBoxChange(TObject *Sender);
        void __fastcall Edit1Click(TObject *Sender);
        void __fastcall Delete1Click(TObject *Sender);
        void __fastcall ListViewClick(TObject *Sender);
	void __fastcall ProxyBoxSelect(TObject *Sender);
	void __fastcall ProxyBoxDropDown(TObject *Sender);
	void __fastcall ProxyBoxCloseUp(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        bool modified, defnntpchanged;
        AnsiString orgwin, defnntp;
        __fastcall TProxyManDlg(TComponent* Owner);
        __fastcall virtual ~TProxyManDlg();
        void __fastcall SetProxies(TStrings *proxies);
        void __fastcall GetProxies(TStrings *proxies);
        void __fastcall GetProxy(TListItem *item, TStrings *proxy);
        void __fastcall SetProxy(TListItem *item, TStrings *proxy);
        void __fastcall LoadSelectorBox(TStrings *proxies);
        void __fastcall CheckReportDefaultProxyMissing();
};
//---------------------------------------------------------------------------
extern PACKAGE TProxyManDlg *ProxyManDlg;
//---------------------------------------------------------------------------
#endif
