/*
*  sampledlgs.cpp 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "sampledlgs.h"
#include "utility.h"
#include "global.h"
#include "mainwins.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSampleDlg *SampleDlg;
//---------------------------------------------------------------------------

__int64 __fastcall HowManyMessages(TForm *Owner, __int64 TotalMsgs)
{
   __int64 msgs = -1;
   TSampleDlg *smpldlg = new TSampleDlg(Owner);
   smpldlg->Label1->Caption = smpldlg->Label1->Caption + " " +
	  IntToStr(TotalMsgs) + " available.";
   smpldlg->totalmsgs = TotalMsgs;
   smpldlg->ShowModal();
   if (smpldlg->ModalResult == mrOk)
   {
	  msgs = smpldlg->totalmsgs;
   }
   delete smpldlg;
   return msgs;
}
//---------------------------------------------------------------------------

__fastcall TSampleDlg::TSampleDlg(TComponent* Owner)
	: TForm(Owner)
{
   totalask = -1;
}
//---------------------------------------------------------------------------

void __fastcall TSampleDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   AnsiString totalstr, nums = "0123456789";
   if (ModalResult == mrOk)
   {
	  totalstr = Msgs->Text;
	  int i = 1; while (i <= totalstr.Length())
	  {
		 if (nums.Pos(totalstr[i]) == 0)
		 {
			MsgBox(this,
			   "The number you entered appears to not be a valid integer. I "
			   "found the character '"+AnsiString(totalstr[i])+"' in the number.",
				MT_INFO, MB_OK);
			{
			   CanClose = false;
			   return;
			}
		 }
		 i++;
	  }
	  totalask = totalstr.ToIntDef(-1);
	  if (totalask < 1)
		 totalask = 1;
	  if (totalask > totalmsgs)
		 totalask = totalmsgs;
	  totalmsgs = totalask;
   }
}
//---------------------------------------------------------------------------

