/*
*  utility.h 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#ifndef utilityH
#define utilityH
#include <classes.hpp>
#include <inifiles.hpp>
#include <forms.hpp>
#include <comctrls.hpp>
#include <assert.h>
#include <dialogs.hpp>
//---------------------------------------------------------------------------

void __fastcall AssignFont(TFont *font, const AnsiString &spec);
AnsiString __fastcall GetFontStr(TFont *font);
AnsiString __fastcall SetTok(int pos, AnsiString text, char divider, const AnsiString &value);
AnsiString __fastcall GetTok(int pos, const AnsiString &text, char divider,
   const AnsiString &def = "");
AnsiString __fastcall GetTokSpc(int pos, const AnsiString &fromStr);
void __fastcall GetUnwrappedText(TCustomMemo *Editor, TStrings *ToStrings);
AnsiString __fastcall GetLastErrorStr(DWORD *errnum = NULL);
void __fastcall look(TStrings *lines, const AnsiString &title = "debug");
void __fastcall LoadWindowPosition(TForm *win, const AnsiString winname, TIniFile *ini);
void __fastcall LoadWindowPosition(TForm *win, const AnsiString winname,
   TListView *listview, TIniFile *ini);
void __fastcall SaveWindowPosition(TForm *win, const AnsiString winname, TIniFile *ini);
void __fastcall SaveWindowPosition(TForm *win, const AnsiString winname,
   TListView *listview, TIniFile *ini);
void __fastcall SetEditRect(TCustomMemo *Editor);
void __fastcall Snooze(DWORD millisecs);
void __fastcall SnoozeT(int millisecs);
HANDLE __fastcall Exec32(const AnsiString& strCmdLine, const WORD ShowCmd=SW_SHOWNORMAL);
HINSTANCE __fastcall ExploreFolder(const AnsiString &strFolder);
AnsiString __fastcall ScrubCap(AnsiString Caption);
void __fastcall TrimNullsBefore(TStrings *text);
void __fastcall TrimNulls(TStrings *text);
void __fastcall TrimNullsAfter(TStrings *text);
bool __fastcall ClearDirectory(const AnsiString &directory);
int __fastcall GetFileNames(TStrings *names, const AnsiString &pathname, int attrib = faAnyFile);
AnsiString __fastcall GetEAddress(const AnsiString &fromline);
AnsiString __fastcall GetDomain(const AnsiString &FromAddress);
TDateTime __fastcall FileDateTime(const AnsiString FileName);
int __fastcall GetFileSize(const AnsiString FileName);
void __fastcall SetRedraw(TWinControl *window, bool set);
void __fastcall CenterDialog(TForm *CenteredForm, TComponent *OtherForm);
void __fastcall ClearString(AnsiString &string);
void __fastcall ZeroString(AnsiString &string);
void __fastcall WipeEditBox(TMemo *editbox);
AnsiString __fastcall GetEAddress(const AnsiString &fromline);
AnsiString __fastcall GetShortName(const AnsiString &FileName);
AnsiString __fastcall DropQuotes(AnsiString &quotedstr);
AnsiString __fastcall dropquotes(AnsiString text);
AnsiString __fastcall DropCrLf(AnsiString line);
AnsiString __fastcall GetSysCompatibleFilename(AnsiString filename);
AnsiString __fastcall withcommas(int num);
AnsiString __fastcall DecodeQuotedPrintable(const AnsiString &text);

void __fastcall LoadWindowPosition(TForm *win, const AnsiString winname,
   TListView *listview, TPanel *Panel, TRichEdit *PreviewPane,
   TIniFile *ini);
void __fastcall SaveWindowPosition(TForm *win, const AnsiString winname,
   TListView *listview, TPanel *Panel, TRichEdit *PreviewPane,
   TIniFile *ini);
AnsiString __fastcall withcommas(int num);

// handle stringlist like ini file section
AnsiString __fastcall ReadString(TStrings *cfg, const AnsiString &name, const AnsiString &defvalue);
int __fastcall ReadInteger(TStrings *cfg, const AnsiString &name, int defvalue);
bool __fastcall ReadBool(TStrings *cfg, const AnsiString &name, bool defvalue);

AnsiString __fastcall GetAdvancedConfigItem(const AnsiString &Name, const AnsiString &DefValue);
bool __fastcall GetAdvancedConfigItem(const AnsiString &Name, bool DefValue);
int __fastcall GetAdvanceConfigItem(const AnsiString &Name, int DefValue);

enum TMsgBoxTypes
{
   MT_WARN,
   MT_ERROR,
   MT_INFO,
   MT_CONFIRM,
   MT_CUSTOM
};

int __fastcall MsgBox(TForm *Owner, const AnsiString &Text, TMsgBoxTypes MsgType,
   UINT Flags);

#define MYMAKELONG(a, b)  ((LONG)(((WORD)(a)) | (((DWORD)((WORD)(b))) << 16)))
#define sm(msg) ShowMessage(AnsiString(msg))

//---------------------------------------------------------------------------
#endif
