/*
*  welcomedlgs.cpp 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <shlobj.h>

#include "welcomedlgs.h"
#include "qsaver.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TWelcomeDlg *WelcomeDlg;
const AnsiString welmsg1 =
"Hey! Thanks for downloading QSAam! This program allows Windows users to locate, "
"download and decrypt incoming nym mail from the newsgroup alt.anonymous.messages. "
"QSAam doesn't setup or create nyms. Its sole purpose is to gather mail for existing nyms.\n\n"
"If you wish to use this program in conjuction with QuickSilver Lite, you should install "
"directly into the QSL home directory--not a subdir of the QSL home.\n\nHowever, that's not "
"required. You can install QSAam stand-alone to any directory. If you put it in the "
"window's Program Files directory, all data files will be stored in the user's Application "
"Data directory, under 'quicksilver\\qsl'. If installing to any other location, all files, "
"including data files will be kept in that single directory. Most prefer the single directory.";
//"I'll open the QuickStart for you to the topic 'Getting Started is Easy.'";
//---------------------------------------------------------------------------

bool __fastcall WelcomeToQSA(TForm* Owner)
{
   TWelcomeDlg *weldlg = new TWelcomeDlg(Owner);
   weldlg->ShowModal();
   bool ok = weldlg->ModalResult == mrOk;
   delete weldlg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TWelcomeDlg::TWelcomeDlg(TComponent* Owner)
	: TForm(Owner)
{
   Caption = QuickSilverAAMVersion();
   RichEdit1->Lines->Text = welmsg1;
   Shortcut->Enabled = !HasShortcut();
}
//---------------------------------------------------------------------------

void __fastcall TWelcomeDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult == mrOk && Shortcut->Enabled && Shortcut->Checked)
      CreateDesktopShortcut();
}
//---------------------------------------------------------------------------

bool __fastcall TWelcomeDlg::HasShortcut()
{
   PItemIDList PIDL;
   char InFolder[MAX_PATH];
   // get the path to users desktop
   SHGetSpecialFolderLocation(0, CSIDL_DESKTOPDIRECTORY, &PIDL) ;
   SHGetPathFromIDList(PIDL, InFolder) ;
   return FileExists(InFolder + AnsiString("\\QuickSilver Aam.lnk"));
}
//---------------------------------------------------------------------------

void __fastcall TWelcomeDlg::CreateDesktopShortcut()
{
   PItemIDList PIDL;
   char InFolder[MAX_PATH];
   WideString LinkName;

   // get the path to users desktop
   SHGetSpecialFolderLocation(0, CSIDL_DESKTOPDIRECTORY, &PIDL) ;
   SHGetPathFromIDList(PIDL, InFolder) ;
   LinkName = InFolder + AnsiString("\\QuickSilver Aam.lnk");

   HRESULT hres;
   IShellLink* psl;
   // Get a pointer to the IShellLink interface.
   hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,
						   IID_IShellLink, (void**)(&psl));
   if (SUCCEEDED(hres))
   {
	  IPersistFile* ppf;
	  hres = psl->QueryInterface(IID_IPersistFile, (void**)(&ppf));
	  if (SUCCEEDED(hres))
	  {
		 // Set the path to the shell link target.
		 psl->SetPath(Application->ExeName.c_str());
		 // Set the description of the shell link.
		 psl->SetDescription("QuickSilver Aam");
		 // Save the link via the IPersistFile::Save method.
		 ppf->Save(LinkName, TRUE);
		 // Release pointer to IPersistFile.
		 ppf->Release();
	  }
	  // Release pointer to IShellLink.
	  psl->Release();
   }
}
//---------------------------------------------------------------------------
